/* sf64r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

real sf64r_c(real *x)
{
    /* Initialized data */

    static real sys001 = 3.141593f;
    static real sys015 = .6366198f;
    static real sys009 = .7853982f;
    static real c__[15] = { .321739f,-.3192986f,.2279979f,-.1009432f,
            .02549149f,-.004051393f,4.411251e-4f,-3.498612e-5f,2.113687e-6f,
            -1.006121e-7f,3.873713e-9f,-1.23194e-10f,3.292e-12f,-7.5e-14f,
            1e-15f };
    static real d__[15] = { -.2486591f,.4589711f,-.2140923f,.04160621f,
            -.001252912f,-8.655585e-4f,1.840992e-4f,-2.041031e-5f,
            1.529526e-6f,-8.503346e-8f,3.689735e-9f,-1.29196e-10f,3.74e-12f,
            -9.1e-14f,2e-15f };
    static real l[21] = { .9927899f,-.007012201f,1.858939e-4f,-1.085647e-5f,
            1.000485e-6f,-1.245563e-7f,1.922551e-8f,-3.490705e-9f,
            7.20159e-10f,-1.64799e-10f,4.1105e-11f,-1.1029e-11f,3.151e-12f,
            -9.51e-13f,3.01e-13f,-1e-13f,3.4e-14f,-1.2e-14f,4e-15f,-2e-15f,
            1e-15f };
    static real h__[24] = { .6075028f,-.01670681f,7.260753e-4f,-5.681213e-5f,
            6.400868e-6f,-9.261211e-7f,1.609903e-7f,-3.22321e-8f,7.223324e-9f,
            -1.775616e-9f,4.71669e-10f,-1.33865e-10f,4.0234e-11f,-1.2715e-11f,
            4.201e-12f,-1.445e-12f,5.15e-13f,-1.89e-13f,7.2e-14f,-2.8e-14f,
            1.1e-14f,-5e-15f,2e-15f,-1e-15f };

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal), sqrt(doublereal),
            log(doublereal);

    /* Local variables */
    static real f, g;
    static integer i__, k, n;
    static real t[47], u, v;

    if (*x <= 0.f) {
        *x = abs(*x);
    }
    t[0] = 1.f;
    if (*x <= 8.f) {
        goto L4;
    }
    t[1] = 8.f / *x;
    for (n = 2; n <= 46; ++n) {
        t[n] = 16.f / *x * t[n - 1] - t[n - 2];
/* L1: */
    }
    u = 0.f;
    v = 0.f;
    for (k = 1; k <= 21; ++k) {
        i__ = (k << 1) - 1;
        u += l[k - 1] * t[i__ - 1];
/* L2: */
    }
    for (k = 1; k <= 24; ++k) {
        i__ = (k << 1) - 1;
        v += h__[k - 1] * t[i__ - 1];
/* L3: */
    }
    ret_val = (real)sqrt((real)(2.f / (sys001 * *x))) *
            (u * (real)sin((real)(*x + sys009)) - 1.f /
            *x * v * (real)cos((real)(*x + sys009)));
    goto L7;
L4:
    t[1] = *x / 8.f;
    for (n = 2; n <= 28; ++n) {
        t[n] = *x / 4.f * t[n - 1] - t[n - 2];
/* L5: */
    }
    f = 0.f;
    g = 0.f;
    for (k = 1; k <= 15; ++k) {
        i__ = (k << 1) - 1;
        f += c__[k - 1] * t[i__ - 1];
        g += d__[k - 1] * t[i__ - 1];
/* L6: */
    }
    ret_val = sys015 * (-(real)log(t[1]) * *x * f + *x * g);
L7:
    return ret_val;
} /* sf64r_c */
